/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file 3d.h
\brief Partie commune a la 3D
*/

#ifndef INCLUDE_3D_H
#define INCLUDE_3D_H

// include general
#include <stdio.h>
#include <math.h>
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>

// gestion de la molette de la souris
#include <shellapi.h>				 // pour ShellExecute
#include <zmouse.h>
#define GET_WHEEL_DELTA_WPARAM(wParam)  ((short)HIWORD(wParam))

// include pour la 3d
// ajouter ./include dans les path des includes
#include <gl/gl.h>                   // Header for OpenGL32 Lib
#include <gl/glu.h>                  // GLu32 Lib
#include <gl/glaux.h>                // GLaux Lib
#include <ftgl/FTGLTextureFont.h>
#include <ftgl/FTGLPixmapFont.h>
#include <ftgl/FTGLExtrdFont.h>
#include <ftgl/FTGLOutlineFont.h>
#include <ftgl/FTGLPolygonFont.h>
#include <ftgl/FTGLBitmapFont.h>

#define FONT_FILE "C:/Windows/Fonts/arial.ttf"

#include "arb_multisample.h"
#include "trigo.h"

#pragma comment(lib, "OpenGL32.lib") 
#pragma comment(lib, "GLu32.lib")
#pragma comment(lib, "GLaux.lib")
#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "lib/ftgl.lib")
#pragma comment(lib, "lib/freetype2.lib")
#pragma comment(lib, "lib/freeimage.lib")

// include de gestion "ordinaire"
#include "MyString.h"
#include "MyTree.h"
#include "MyList.h"
#include "MyRegistry.h"

// include pour debugage
#include "MyDebug.h"

// macros de definition de type de face
#define FACE_BACK		0
#define FACE_BOTTOM		1
#define FACE_TOP		2
#define FACE_LEFT		3
#define FACE_RIGHT		4
#define FACE_FRONT		5

#define VERSION			"0.7"		// version du moteur en cours

// enum de positionnement
typedef enum { top=1,bottom=2,left=4,right=8 } DockPos;
#endif