/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file Object3D.h
\brief Affiche des object 3D de base
*/

#ifndef INCLUDE_OBJECT_3D_H
#define INCLUDE_OBJECT_3D_H

#include "color.h"

/*!
\brief Object 3D

List des objects:
	- Pointeur (DrawArrow)
	- Repere xyz (DrawRepere)
	- Vecteur (DrawVector)
	- Vecture de taill limite (DrawVectorMinMax)
*/
class Object3D
{
public:
	static HDC hDC;
	static void DrawArrow(Color color);
	static void DrawRepere();
	static void DrawText(char *text);
	static void DrawVector(double x,double y);
	static BOOL DrawVectorMinMax(double x,double y,double minIntensity,double maxIntensity);
};

#endif
