/* *************************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
************************************************************************************* */

#include "3d.h"
#include "MyString.h"
#include "controlEngine.h"
#include "textTexture.h"

extern ControlEngine ce;

TextTexture::TextTexture()
{
	texture=NULL;
	faceText=NULL;
	background=RGB(128,128,128);
	color=RGB(0,0,0);
	xFormat=-1;
	yFormat=-1;
}

void TextTexture::BindTexture(Face *face)
{
	faceText=face;
}

void TextTexture::operator=(char *newText)
{
	SetText(newText);
}

void TextTexture::SetText(char *newText)
{
	text=newText;
	RefreshText();
}

void TextTexture::RefreshText()
{
	if (texture)
	{
		texture->Delete();
		delete texture;
		texture=NULL;
	}
	texture = new Texture;
	texture->FromText("text",text,color,background,xFormat,yFormat);
	MajTexture();
}

BOOL TextTexture::MajTexture()
{
	if (!texture||!faceText) return FALSE;
	faceText->texture = texture;
	return TRUE;
}
