/* *************************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
************************************************************************************* */

#ifndef INCLUDE_TEXT_TEXTURE_H
#define INCLUDE_TEXT_TEXTURE_H

#include "face.h"

/*!
\brief Propriete d'un control a avoir une face avec du text

Example:
\code
#include "TextTexture.h"

class TheControl: public Control , public TextTexture
{
	Create()
	{
		//... init graphique
		Bind(faceNode->Elems(FACE_FRONT));
		MajTexture();
	}
}

void TextIt()
{
	TheControl theControl;
	theControl="The text"; // change la texture
}
\endcode
*/

class TextTexture
{
public:
	MyString text;
	Texture *texture;
	COLORREF background;
	COLORREF color;
	int xFormat;
	int yFormat;
	Face *faceText; // graphics du conteneur

public:
	TextTexture();
	void operator=(char *newText);
	void SetText(char *newText);
	void SetXYFormat(int x,int y){xFormat=x; yFormat=y;}
	void RefreshText();
	void BindTexture(Face *face);
	BOOL MajTexture();
};

#endif