/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file angles.h
\brief Gestion mixe des angles d'euler et quaternion
*/

#ifndef INCLUDE_ANGLES_H
#define INCLUDE_ANGLES_H

#include "trigo.h"
#include "include/quaternion.h"


class Angles 
{
private:
	Quaternion quaternion;
	Point3D<double> euler;
	BOOL isUpdatedEuler;
	BOOL isUpdatedQuaternion;

	void Zero();

public:
	Angles();
	Point3D<double> GetEuler();
	void operator= (Angles &src);

	Angles(Point3D<double> &relativeAngles);
	void Rotate(Point3D<double> &relativeAngles);
	void Set(Point3D<double> &relativeAngles);
	void Add(Point3D<double> &relativeAngles);

	Angles(double x,double y,double z) ;
	void Rotate(double x,double y,double z);
	void Set(double x,double y,double z);
	void Add(double x,double y,double z);
};

#endif
