/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file button.h
\brief Control Button
*/

#ifndef INCLUDE_BUTTON_H
#define INCLUDE_BUTTON_H

#include "control.h"

class EventButton
{
public:
	signal0<> click; // call: void Click();
	signal1<BOOL> checked; // call: void Checked(BOOL isPush);
};

/*!
\brief
Class de parametre et d'evenement d'un "Bouton"
*/

class Button : public Control
{
private:
	// config des modes
	BOOL pushLikeMode;
	BOOL allButtonMode;

	int OnTimerPushDown(Timer *timer);

public:
	// varaible membre
	MyString caption;
	double depth_max,depth_min,depth_cur;
	double timeOut;
	BOOL isPushed;
	Material materialOnUp;
	Material materialOnDown;
	Material *materialCurrent;
	Text3D text;
	
	// evenements
	EventButton onButton;
	Timer timerPushDown;

	Button();
	~Button();

	virtual void Create() { Create(DEFAULT_DEPTH_MAX_BUTTON); } // Createur pour container
	void Create(double depth);
	void operator=(char *newCaption);
	void SetText(char *newCaption);
	void ToString(MyString &str);
	void PushUp();

	void SetPush(BOOL enable);
	void SetPushToogle();
	BOOL GetPush();

	void ModePushLike(BOOL enable);
	void ModeAllButtons(BOOL enable);

	int OnPushDown(StateMouse *mouse,int face);
	int OnPushUp(StateMouse *mouse,int face);
	int OnOverOut(Control *newControl,int face);
	int OnOverIn(Control *oldControl,int face);
};

#endif