/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file calculator.h
\brief Control Calculator
*/

#ifndef INCLUDE_CALCULATOR_H
#define INCLUDE_CALCULATOR_H

#include "window.h"

typedef enum
{
	Op_Null,Op_Add,Op_Sub,Op_Div,Op_Mult
} TOpperation;

class Opperation
{
public:
	double number;
	TOpperation op;

	Opperation();
	void operator=(Opperation &src);
	void GetText(MyString &result);
	static double Compute(double param1,TOpperation op,double param2);
};

/*!
\brief
Class de parametre et d'evenement d'un "Calculator"
*/

class Calculator : public Window
{
private:
	Button btnNumbers[10];
	Button btnAdd;
	Button btnSub;
	Button btnDiv;
	Button btnMult;
	Button btnEqual;
	Button btnDot;
	Button btnClear;
	TextBox txtResult;
	TextBox txtResultBase;
	MyList<Opperation> lOpperation;

	Texture textureIcon;
	MyString lineCur;

	void MajResult();
	void Compute();

public:
	Calculator();	
	void Create();

	int OnKey(StateKey *key,int face);
	void OnNum(int num);
	int OnNum0();
	int OnNum1(); 
	int OnNum2();
	int OnNum3();
	int OnNum4(); 
	int OnNum5();
	int OnNum6(); 
	int OnNum7(); 
	int OnNum8();
	int OnNum9();
	int OnDot();
	int OnClear();
	int OnEqual();
	int OnAdd();
	int OnSub();
	int OnMult();	
	int OnDiv();
	int OnOk();
};

#endif