/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

#include "3d.h"
#include "color.h"

Color::Color()
{
	Zero();
}

Color::Color (float r,float g,float b,float a)
{
	Set(r,g,b,a);
}

Color::Color (float rgba)
{
}
void Color::Zero()
{
	r=0;
	g=0;
	b=0;
	a=1;
	isEnable = FALSE;
}

void Color::operator=(Color &source)
{
	r = source.r;
	g = source.g;
	b = source.b;
	a = source.a; 
	isEnable = source.isEnable;
}

void Color::operator=(float *source)
{
	r = source[0];
	g = source[1];
	b = source[2];
	a = source[3]; 
	isEnable = TRUE;
}

void Color::SetNull()
{
	Set(0,0,0,0);
}

void Color::SetFull()
{
	Set(1,1,1,1);
}

void Color::Set(float _r,float _g,float _b)
{
	r = _r;
	g = _g;
	b = _b;
	isEnable = TRUE;
}

void Color::Set(float _r,float _g,float _b,float _a)
{
	r = _r;
	g = _g;
	b = _b;
	a = _a;
	isEnable = TRUE;
}

Color::operator float *() const 
{
	return (float *)&value;
}
void Color::ToString (MyString &text)
{
	text<<"[enable,r,g,b,a]: "<<isEnable<<" , "<<r<<" , "<<g<<" , "<<b<<" , "<<a;
}