/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file color.h
\brief Gestion des couleur en 3D
*/

#ifndef INCLUDE_3D_COLOR_H
#define INCLUDE_3D_COLOR_H

typedef struct 
{
	float r;
	float g;
	float b;
	float a;
} RGBA;

/*!
\brief
Gestion des couleurs en 3D
valeur de [0;1]
parametre: value ou {r,g,b,a}
*/
class Color
{
public:	
	union
	{
		float value[4];
		struct 
		{
			float r;
			float g;
			float b;
			float a;
		};
	};
	BOOL isEnable;

public:
	Color();
	Color(float r,float g,float b,float a);
	Color(float rgba);
	void Zero();
	void operator=(Color &source);
	void operator=(float *source);

	void SetNull();
	void SetFull();
	void Set(float _r,float _g,float _b);
	void Set(float _r,float _g,float _b,float _a);
	operator float *() const;
	void ToString (MyString &text);
};

#endif