#include <windows.h>
#include "CommunTools.h"
#include "MyString.h"
#include <stdio.h>

// ***********************************************************************************

void DrawTextOnFirstPlan(char *text,BOOL shadowMode)
{
	int len = (int)strlen(text);
	HWND hWnd = GetDesktopWindow();
	HDC hDC = GetDC(NULL); 

	HFONT hFont = CreateFont(100,45,0,0,0,0,0,0,0,0,0,0,0,"Arial");
	HFONT hFontOld = (HFONT) SelectObject(hDC,hFont);
	RECT rect;
	GetWindowRect(hWnd,&rect);

	SetBkMode(hDC,TRANSPARENT);

	if (shadowMode)
	{
		SetTextColor(hDC, RGB(64,64,64));
		for (int i=0;i<3;i++)
		{
			for (int j=0;j<3;j++)
			{
				DrawText(hDC,text,len,&rect,DT_CENTER|DT_VCENTER|DT_SINGLELINE);
				rect.right+=1;
				rect.left+=1;
			}
			rect.right-=3;
			rect.left-=3;
			rect.bottom+=1;
			rect.top+=1;
		}

		// affiche le text
		rect.right+=1;
		rect.left+=1;
		rect.bottom-=2;
		rect.top-=2;
	}
	SetTextColor(hDC, RGB(0,255,0));
	DrawText(hDC,text,len,&rect,DT_CENTER|DT_VCENTER|DT_SINGLELINE);
	SelectObject(hDC,hFontOld);
}			

/*!
\brief Ouvre un browser internet, utilise un ShellExecute
*/

void MyOpenBrowser(char *url)
{
	char Browser[MAX_PATH];
	char RegPath[MAX_PATH + MAX_PATH];
	char RegValue [MAX_PATH + MAX_PATH] ;
	DWORD DataSize = MAX_PATH;
	static HINSTANCE hShell=NULL;
	DWORD type = REG_SZ ;
	HKEY hKey;

	RegOpenKeyEx(HKEY_CLASSES_ROOT, ".htm", 0, KEY_QUERY_VALUE, &hKey);
	RegQueryValueEx(hKey,NULL,NULL,&type,(unsigned char *)RegPath,&DataSize);
	RegCloseKey(hKey);

	strcat(RegPath,"\\shell\\open\\command");
	DataSize = MAX_PATH*2; type = REG_SZ ;
	RegOpenKeyEx(HKEY_CLASSES_ROOT, RegPath,0, KEY_QUERY_VALUE ,&hKey) ;
	RegQueryValueEx(hKey,NULL,NULL,&type,(unsigned char *)RegValue,&DataSize) ;

	RegCloseKey(hKey);

	char *pos = strstr(RegValue,"\"%1\"");
	if(!pos )    
	{   
		pos = strstr(RegValue,"%1");
		if(pos == NULL) pos = RegValue+strlen(RegValue)-1;
		else  *pos = '\0';    
	} else *pos = '\0'; 
	pos = strstr(RegValue, " -") ; 
	if (pos != NULL) *pos = '\0' ;
	char *q = Browser ;
	for (size_t i = 0; i < strlen (RegValue) ; i++) 
	{
		if (RegValue[i] != '\"') 
		{
			*q = RegValue[i];
			q++ ;
		}
	}
	*q = '\0' ;

	ShellExecute(NULL,"open",Browser,url,NULL,SW_SHOW);
}

// *************************************************************************************************************************

void ErrorMessage(BOOL useLastError, UINT type, const TCHAR* message, ...)
{
	const INT bufferSize = 4096;
	static TCHAR buffer[bufferSize];

	if(message != NULL)
	{
		va_list ap;
		va_start(ap, message);
		vsprintf(buffer, message, ap);
		va_end(ap);
	}
	else
		lstrcpy(buffer, TEXT(""));

	if(useLastError)
	{
		DWORD lastError = GetLastError();

		TCHAR* lastErrorMsg = NULL;
		DWORD size = FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			lastError,
			0,
			(TCHAR*)&lastErrorMsg,
			bufferSize / 2,
			NULL);
		if(size == 0)
			SetLastError(lastError);

		const TCHAR unknownError[] = TEXT("Unknown error.");

		if(lstrlen(buffer) > 0)
		{
			static TCHAR temp[bufferSize];
			wsprintf(
				temp,
				TEXT("%s\n\n%s"),
				buffer,
				(lastErrorMsg != NULL) ?
lastErrorMsg : unknownError);
			lstrcpy(buffer, temp);
		}
		else
			lstrcpy(
			buffer,
			(lastErrorMsg != NULL) ?
lastErrorMsg : unknownError);

		if(lastErrorMsg != NULL)
			LocalFree(lastErrorMsg);
	}

	HWND hWndFocus = GetFocus();
	MessageBox(NULL, buffer, "Error on 3D Controls", type);
	if(hWndFocus != NULL && IsWindow(hWndFocus)) SetFocus(hWndFocus);
}

// *********************************************************************************

BOOL Run(char *exe,char *message)
{
	char *prog = exe;
	char *parameter = NULL;

	char sep=' ';
	if (exe[0]=='\"')
	{
		sep='\"';
		prog++;
	}

	for (unsigned int i=0;i<strlen(prog);i++)
		if (prog[i]==sep) 
		{
			if (i<(strlen(prog)-1)) parameter = prog+i+1+(sep=='\"');
			prog[i]='\0';
			break;
		}

		HINSTANCE hInstExe = ShellExecute(NULL,"open",prog,parameter,NULL,SW_SHOW);
		BOOL state =FALSE;
		MyString textErr;
		switch ((long)hInstExe)
		{
		case 0:  textErr="The operating system is out of memory or resources."; break;
		case ERROR_FILE_NOT_FOUND: textErr="The specified file was not found."; break;
		case ERROR_PATH_NOT_FOUND: textErr="The specified path was not found."; break;
		case ERROR_BAD_FORMAT: textErr="The .exe file is invalid (non-Win32 .exe or error in .exe image)."; break;
		case SE_ERR_ACCESSDENIED: textErr="The operating system denied access to the specified file. ";break;
		case SE_ERR_ASSOCINCOMPLETE: textErr="The file name association is incomplete or invalid."; break;
		case SE_ERR_DDEBUSY: textErr="The DDE transaction could not be completed because other DDE transactions were being processed."; break;
		case SE_ERR_DDEFAIL:  textErr="The DDE transaction failed."; break;
		case SE_ERR_DDETIMEOUT:  textErr="The DDE transaction could not be completed because the request timed out."; break;
		case SE_ERR_DLLNOTFOUND:  textErr="The specified dynamic-link library was not found."; break;
		case SE_ERR_NOASSOC:  textErr="There is no application associated with the given file name extension."; break;
		case SE_ERR_OOM:  textErr="There was not enough memory to complete the operation."; break;
		case SE_ERR_SHARE: textErr="A sharing violation occurred."; break;
		default:
			state = TRUE;
			textErr = "Lancemennt correct !";
		}

		if (message) strcpy (message,textErr);

		if (parameter) prog[i]=sep;
		return state;
}

void MailTo (char *eMail)
{
	MyString temp;
	temp<<"mailto:"<<eMail;
	ShellExecute(NULL,"open",temp,NULL,NULL,0);
}