/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file cubedock.h
\brief Control Dock en cube
*/

#ifndef INCLUDE_CUBEDOCK_H
#define INCLUDE_CUBEDOCK_H

#include "control.h"
#include "linedock.h"
#include "dock.h"

/*!
\brief
Docker: test le click sur une partie zone cubique
*/
class CubeDock
{
public:
	Control *parent;
	LineDock frontTop,frontBottom,frontLeft,frontRight;
	Dock frontTopRight,frontTopLeft,frontBottomLeft,frontBottomRight;
	LineDock backTop,backBottom,backLeft,backRight;
	Dock backTopRight,backTopLeft,backBottomLeft,backBottomRight;

	CubeDock()
	{
		parent=NULL;
	}

	void Config(Control *_parent,double width=-1) //wifth=-1==> valeur par default
	{
		parent=_parent;
		frontTop.Set(0,0,0, 1,0,0,width);
		frontBottom.Set(0,1,0, 1,1,0,width);
		frontLeft.Set(0,0,0, 0,1,0,width);
		frontRight.Set(1,0,0, 1,1,0, width);
		frontTopLeft.Set(0,0,0,width);
		frontTopRight.Set(1,0,0,width);
		frontBottomLeft.Set(0,1,0,width);
		frontBottomRight.Set(1,1,0,width);
		backTop.Set(0,0,1, 1,0,1,width);
		backBottom.Set(0,1,1, 1,1,1,width);
		backLeft.Set(0,0,1, 0,1,1,width);
		backRight.Set(1,0,1, 1,1,1,width);
		backTopLeft.Set(0,0,1,width);
		backTopRight.Set(1,0,1,width);
		backBottomLeft.Set(0,1,1,width);
		backBottomRight.Set(1,1,1,width);
	}
	~CubeDock()
	{
	}
};

#endif