/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file cursor.h
\brief Affiche le curseur
*/

#ifndef INCLUDE_CURSOR_H
#define INCLUDE_CURSOR_H

#include "color.h"
#include "control.h"

/*!
\brief Curseur 3D

*/

typedef enum
{
	cursorArrow,
	cursorWait,
	cursorText,
	cursorMoving,
	cursorRepere,
	cursorPush,
	cursorNoChange,
	cursorNothing
} CursorType;

class Cursor 
{
public:
	CursorType curType;
	CursorType leftType,rightType,midType;
	Face curFace;
	Face leftFace;
	Face midFace;
	Face rightFace;
	Recorder recorderRepere;

	Cursor();
	void Create();
	void ApplyType(Face *face,CursorType type);
	void ApplyTypes(CursorType current=cursorNoChange,CursorType left=cursorNoChange,CursorType mid=cursorNoChange,CursorType right=cursorNoChange);
	void Rotate(Face *face,CursorType type,Point3D<double> angle);
	void Rotate(Point3D<double> angle);
	void Draw(double x,double y);

	Point2D<int> GetHotSpot(CursorType type);
	void DrawArrow(Color color);
	void DrawRepere();
	void DrawText(char *text);
	void DrawVector(double x,double y);
	BOOL DrawVectorMinMax(double x,double y,double minIntensity,double maxIntensity);
};

#endif
