/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file curve.h
\brief Gestion de l'incurvation d'une face
*/

#ifndef INCLUDE_CURVE_H
#define INCLUDE_CURVE_H

#include "3d.h"
#include "coordonate.h"
#include "texture.h"

/*!
\brief Gestion des l'incurvation d'une face
*/
class Curve
{
private:
	// variable avec les valeurs precalcul
	Point2D<int> oldNbCut;
	GLdouble *tabSommets;
	GLdouble *tabCoorTextures;
	GLuint *tabQuads;
	Coordonate<GLdouble> oldCenter; // centre de l'incurvation
	void UnAlloc();
	int numList;

public:
	Point2D<int> nbCut;	// nb de decoupe en X et Y
	Coordonate<GLdouble> center; // centre de l'incurvation

public:
	Curve();
	~Curve();
	void Zero();
	void operator=(Curve &source);
	BOOL Set(GLdouble zCenter,int nbCutXY);
	BOOL Set(GLdouble zCenter,int nbCutX,int nbCutY);
	BOOL IsActive();
	void Refresh();
	BOOL Draw(Point2D<double> size,Texture *texture);
};

#endif