/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file input_instance.h
\brief Instanciation static de input

doit etre inclus a partir du fichier main
sinon les constructeurs des class utiliss dans les variables static 
d'une variable global sera lanc apres utilsation dans la class (donc re-initialisation)
\code
//>>> fichier A.h <<<
class A { public: int nb; A(){nb++;} };
//>>> fichier A.cpp <<<
A B::a = 0; // instanciation
//>>> fichier main.cpp <<<
class B { public: static A a; };
B b1; // A::nb=1
void main() { B b2; } // A::nb devrai =2 mais en fait =1 car instanciation fait apresEventde parametre et d'evenement d'une "Window"Control boutton
\endcode
*/

#include "3d.h"
#include "input.h"

// instanciation des variables static membre de TimerEvent
MyList<Timer *> Timer::list;
int Timer::nextFreeId=10; // 0 a 10 reserv pour l'application
HWND Timer::hWnd; 
LARGE_INTEGER Timer::frecTimer;