/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file linedock.h
\brief Control Dock en ligne
*/

#ifndef INCLUDE_LINEDOCK_H
#define INCLUDE_LINEDOCK_H

#include "control.h"
#include "dock.h"

#define DEFAULT_WIDTH 0.1

/*!
\brief Dock en ligne

Test le click sur une zone d'une ligne d'une certaine epaisseur
(a utiliser pour faire un "Splitter")
*/
class LineDock : public Control
{
public:
	double width;
	double xDeb,yDeb,zDeb;
	double xFin,yFin,zFin;

	LineDock()
	{
		width = DEFAULT_WIDTH;
	}
	~LineDock()
	{
	}

	void Set(double _xDeb,double _yDeb,double _zDeb,double _xFin,double _yFin,double _zFin,double width=-1)
	{
		xDeb=_xDeb;
		yDeb=_yDeb;
		zDeb=_zDeb;
		xFin=_xFin;
		yFin=_yFin;
		zFin=_zFin;
		if (width==-1) width = DEFAULT_WIDTH;
	}
};

#endif