/* *************************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
************************************************************************************* */

#include "3d.h"
#include "input.h"
#include "controlEngine.h"
#include "myList.h"
#include "texture.h"
#include "button.h"
#include "textBox.h"
#include "container.h"
#include "window.h"
#include "msgBox.h"


extern ControlEngine ce;

MsgBox::MsgBox()
{
	useCancel=TRUE;
	name="MsgBox";
	title="Question";
	title.useMax = FALSE;
	title.useMin = FALSE;


	title.btnClose.onButton.click.connect(this,OnClose);
	btnOk="Ok";
	btnOk.name="btnOk";
	btnOk.onButton.click.connect(this,OnButtonOk);

	btnCancel="Cancel";
	btnCancel.name="btnCancel";
	btnCancel.onButton.click.connect(this,OnClose);

	txtInfo="Information";
	txtInfo.name="txtInfo";
	txtInfo.isReadOnly=TRUE;

	txtHelp="Aide:\n\nUn MsgBox permet d'afficher des valeurs simples";

	txtTranche="MsgBox";
}

MsgBox::~MsgBox()
{
}

void MsgBox::Create()
{
	Window::Create();
	FaceNode *nodeCur;
	ce.Push(&client);
	nodeCur = ce.primitive.GoTo(FACE_FRONT);
		// bouton OK
		btnOk.Create(); // create doit il passer en parametre un layout ?
		btnOk.Size(50,20);
		btnOk.faceNode->elem->center.Set(0,1);
		btnOk.faceNode->elem->position.x.Set(0,useCancel?1/4.0:0,&nodeCur->elem->computeSize.x);
		btnOk.faceNode->elem->position.y.Set(2,-0.5,&nodeCur->elem->computeSize.y);

		// bouton cancel
		if (useCancel)
		{
			btnCancel.Create(); 
			btnCancel.Size(50,20);
			btnCancel.faceNode->elem->center.Set(0,1);
			btnCancel.faceNode->elem->position.x.Set(0,-1/4.0,&nodeCur->elem->computeSize.x);
			btnCancel.faceNode->elem->position.y.Set(2,-0.5,&nodeCur->elem->computeSize.y);
		}

		// text d'information
		txtInfo.Create();
		txtInfo.XDockCenter(2,0);
		txtInfo.YDockTop(2,0);

		txtInfo.faceNode->elem->size.y.Set(-26,1,&nodeCur->elem->computeSize.y);
	ce.Pop();
	ce.Push(this);
		nodeCur = ce.primitive.GoTo(FACE_BACK);
		// text aide
		txtHelp.Create();
		txtHelp.faceNode->elem->angle.z=180;
		txtHelp.XDockCenter(2,2);
		txtHelp.YDockCenter(2,2);
		ce.primitive.GoToParent();
	
		nodeCur = ce.primitive.GoTo(FACE_LEFT);
		// text sur la tranche
		txtTranche.Create();
		txtTranche.text.scale=0.5;
		txtTranche.text.material.SetDS(0,0,1);
		txtTranche.faceNode->elem->angle.z=90;
		txtTranche.faceNode->elem->size.x.Set(0,1,&nodeCur->elem->computeSize.y);
		txtTranche.faceNode->elem->size.y.Set(0,1,&nodeCur->elem->computeSize.x);
	ce.Pop();
}

/*!
\brief bouton Ok de la zone client clicker

\todo evenement a gerer pour differention Ok de Cancel (valeur de retour ?
*/
int MsgBox::OnButtonOk ()
{
	Debug0Param("MsgBox::OnButtonOK");
	OnClose();
	return 0;
}

// bouton Cancel de la zone client clicker
int MsgBox::OnClose()
{
	Debug0Param ("MsgBox::OnClose");
	MsgBox::Delete();
	Window::OnClose();
	return 0;
}
