/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file picking.h
\brief Gestion du picking 3D
*/

#ifndef INCLUDE_PICKING_H
#define INCLUDE_PICKING_H

#include "3d.h"
#include "input.h"

#define MAX_BUFFER_SELECT		512		// taille du buffer du picking

class Control; 
/*!
\brief Gestion du picking
*/
class Picking
{
private:
	void TestOvers();
	void TestOver(Control *lastControl,int lastFace,Control *control,int face);

public:
	Control *lastControlHover;	//!< derniere control survol utilis
	Control *lastControlContainer;	//!< dernier control container utilis
	int lastFaceHover;			//!< derniere face survol utilis
	int lastFaceContainer;		//!< derniere face container utilis
	StateMouse mouse,oldMouse;	//!< infos / souris
	Control *controlHover;		//!< control survol
	Control *controlContainer;  //!< control slection
	int	faceHover;			//!< face du control survol
	int	faceContainer;		//!< face du control slection
	double zDist;				//!< distance z observateur <=> objet 3D
	BOOL isMoving;				//!< les coordone on est chang depuis la derniere fois

public:
	Picking();

	void operator=(Picking &scr);
	BOOL Test();					//!< test OpenGL du picking
	BOOL FindContainer();			//!< trouve le container
	void SetMousePos(int x,int y);	//!< place les coordonne de la souris
	void SetDeltaWheel(int delta);	//!< place le delta wheel de la souris

	void UpdateLast();
	void ResetLast();
	void ResetCurrent();

	void OnMouseMove(int x,int y);
	void OnMouseWheel(int delta);
	void OnLButtonUp();
	void OnMButtonUp();
	void OnRButtonUp();
};

#endif