/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html	
*********************************************************************************** */

/*! \file polygonMode.h
\brief Gestion du mode de rendu polygonale
*/

#ifndef INCLUDE_POLYGON_MODE_H
#define INCLUDE_POLYGON_MODE_H

typedef enum
{
	fill = GL_FILL,
	line = GL_LINE,
	point = GL_POINT
} PolygonModeType;

/*!
\brief Gestion du mode d'affichage des polygons
*/
class PolygonMode
{
public:
	PolygonModeType front,back;
	PolygonMode()
	{
		front = fill;
		back = fill;
	}

	void Use(PolygonModeType _front,PolygonModeType _back)
	{
		front = _front;
		back = _back;
		Use();
	}

	void Use()
	{
		glPolygonMode(GL_FRONT, front);
		glPolygonMode(GL_BACK, back);
	}

	void ToString(MyString &src)
	{
		MyString frontTxt,backTxt;
		Traduce(front,frontTxt);
		Traduce(back,backTxt);
		src<<"front:"<<frontTxt<<" back:"<<backTxt;
	}

	void Traduce(PolygonModeType mode,MyString &dest)
	{
		switch(mode)
		{
		case fill: dest="fill"; break;
		case line: dest="line"; break;
		case point: dest="point"; break;
		default: dest="<Unknown>";
		}
	}
};

#endif