/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

#include "3d.h"
#include "recorder.h"

Recorder::Recorder()
{
	Zero();
}

void Recorder::Zero()
{
	id=0;
}

Recorder::~Recorder()
{
	Delete();
}

void Recorder::operator=(Recorder &src)
{
	id=src.id;
}

BOOL Recorder::BeginRecord(BOOL andExecute)
{
	Delete();
	id = glGenLists(1);
	if (!id) return FALSE;
	glNewList(id,andExecute?GL_COMPILE_AND_EXECUTE:GL_COMPILE);
	return TRUE;
}

void Recorder::EndRecord()
{
	glEndList();
}

void Recorder::Play()
{
	glCallList(id);
}

BOOL Recorder::Delete()
{
	if (!id) return FALSE;
	glDeleteLists(id,1);
	Zero();
	return TRUE;
}