/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file region.h
\brief Gestion des region de Windows
*/

#ifndef INCLUDE_REGION_H
#define INCLUDE_REGION_H

#include "trigo.h"
#include <gl/gl.h>                   // Header for OpenGL32 Lib
#include "myList.h"

typedef Point3D<double> Pt_3D_Double;

/*!
\brief Gestion des region windows

Elle permet l'utilisation du mode cooperativeWindows ou elle detoure les object 3DS.
Elle applique alors les API Windows sur les regions
*/
class Region
{
public:
	BOOL    enable;
	BOOL	computeMinMax;
	MyList<Pt_3D_Double> points;
	int		xMin,xMax; // boite englogante 2d de l'univers 3d
	int		yMin,yMax;
	int		zMin,zMax;
	int		nbOr; // nb Or de region
	HRGN	hRgnBase;

public:
	Region();
	void Reset(int deltaXwin=0,int deltaYwin=0);
	BOOL Use(HWND hWnd);
	void NormalizeSens(POINT *tabPoints,int nbPt);
	void SetMinMax(POINT *tabPoints,int nbPt);
	BOOL AddElem(Point2D<GLdouble> pos,GLdouble *modelMatrix,GLdouble *projMatrix,GLint *viewPort);
	BOOL Compute(Point2D<GLdouble> pos,GLdouble *modelMatrix,GLdouble *projMatrix,GLint *viewPort,Point3D<double> *pt);

};

#endif