/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file screen.h
\brief Gestion du fenetrage du context OpenGL
*/

#ifndef INCLUDE_SCREEN_H
#define INCLUDE_SCREEN_H

#include <windows.h>
#include "myString.h"
#include "region.h"

class Screen
{
private:
	HWND hWndInsertAfter;
	HINSTANCE hInst;
	MyString title;
	MyString className;
	BOOL enableFullScreenOld;

	int xNormal;
	int yNormal;
	int dxClient;
	int dyClient;
	int dxFull;
	int dyFull;
	int dxWC;
	int dyWC;

	DWORD dwExStyle;
	DWORD dwStyle;

	void Adjust();
	void ComputeDeltaClientToWindow();

public:
	HDC	  hDC;					//!< context graphic au sens Windows			
	HGLRC hGLRC;				//!< context graphic au sens OpenGL	

	BOOL enableTitle;
	BOOL enableFullScreen;

	int dxNormal;
	int dyNormal;

	HWND hWnd;
	Region region;	//!< system de regionage en mode "Cooperatif Windows"				

	// init
	Screen();
	~Screen();
	BOOL Setup(WNDCLASS *wc,char *_className,char *_title);
	BOOL Create(HINSTANCE hInstance);
	void Destroy();
	void Show(BOOL enable);
	void Update(BOOL applySize);
	void SetSize(int dx,int dy,BOOL always);

	void BindOpenGL(BOOL useAccumulation);
	BOOL SwapBuffers();

	// modes
	void SetTopMost();
	void SetTitle(char *_title);
	void SetFullScreen();
	
	// styles
	void ApplyStyles();
	void ApplyStyle();
	void ApplyStyleEx();
	void ChangeStyle(int set,DWORD dwStyleChange);
	void ChangeStyleEx(int set,DWORD dwStyleChange);
	void SetStyle(DWORD _dwStyle);
	void MsgInfoType();
	void ApplySize();

	// region
	void RegionReset();
	void RegionUse();
};
#endif
