/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file textBox.h
\brief Control d'affichage de text'
*/

#ifndef INCLUDE_TEXT_BOX_H
#define INCLUDE_TEXT_BOX_H

#include "TextTexture.h"

class EventTextBox
{
public:
	signal2<int,int> setCursor; //!<Call(int column,int line); Le curseur est positionn
	signal0<> change; //!<Call() Quelque chose a ete modifi
};

/*!
\brief Une "TextBox" est un control permetant l'affichage (isReadOnly=TRUE) et la saisie de text
*/
class TextBox : public Control
{
public:
	BOOL isReadOnly;
	EventTextBox onTextBox;
	Text3D text;

	TextBox();
	~TextBox();
	virtual void Create() { Create(DEFAULT_DEPTH_TEXTBOX); } // Createur pour container
	virtual void Create(double depth);
	void ToString(MyString &str);
	void SetCursor(int column,int line); // le curseur a ete positionner
	void operator=(char *newText);
	void SetText(char *newText);

	int OnLButtonDown(StateMouse *mouse,int face); // on a clicker sur le control ==> curseur a l'emplacement de la souris
	int OnLButtonUp(StateMouse *mouse,int face); // on a clicker sur le control ==> curseur a l'emplacement de la souris
	int OnOverIn(Control *oldControl,int face);
};

#endif