/* *************************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
************************************************************************************* */

#include "3d.h"
#include "input.h"
#include "controlEngine.h"
#include "tip.h"

extern ControlEngine ce;

Tip::Tip()	
{
	// init variable
	name="Tip";
	text.Setup(ce.fontTexture,ft_texture);
	text.SetAlign(align_center,align_center);
	text.SetWrapping(FALSE,TRUE,TRUE);
	text.material.SetDS(1,1,1,1);
}

Tip::~Tip()
{
}

// ********************************************************************************

void Tip::Create()
{
	SetParent();

	// init general
	faceNode = ce.primitive.AddFace(name,id,-1,TRUE); 
	Face *face = faceNode->elem;
	face->text=&text; // attache le text
	face->material.SetDS(1,1,0,0.3f);
	face->blending=TRUE;
}

// ********************************************************************************

void Tip::operator=(char *newCaption)
{
	text.SetText(newCaption);
}

void Tip::SetText(char *newCaption)
{
	text.SetText(newCaption);
}

// ********************************************************************************

void Tip::ToString(MyString &str)
{
	str.AddFormat("name: %s",name);
}

// ********************************************************************************
// ********************************************************************************
// ********************************************************************************
// ********************************************************************************
// ********************************************************************************
// ********************************************************************************
