/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr
	
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file Treeview.h
\brief Control TreeView
*/

#ifndef INCLUDE_TREEVIEW_H
#define INCLUDE_TREEVIEW_H

#include "control.h"

class TreeViewItem
{
public:
	MyString text;
	BOOL isCollaps;
	BOOL contentSub;
	BOOL askSubData;
	int idControl;

	TreeViewItem()
	{
		isCollaps=TRUE;
		contentSub=FALSE;
		askSubData=FALSE;
		idControl=-1;
	}
};

typedef MyTreeNode<TreeViewItem> TreeNode;

class EventTreeView
{ 
public:
	signal1<TreeNode *> select;
};

/*!
\brief
Class de parametre et d'evenement d'une "TreeView"
*/

class TreeView : public Control
{
private:
	int  DrawRecursif(TreeNode *node,double margeY,int level);
	void AddTreeButton(Button *button,BOOL isCollaps);
	TreeNode * FindOnData(int idControl,TreeNode *node);
	double posY;
	void Test(Control *control);
	int OnClickPlus();

public:
	MyTree<TreeViewItem> data;
	EventTreeView onTreeView;

	TreeView();
	void Create();
	void Draw ();
	TreeNode * FindOnData(int idControl);
	void GetTreePath(TreeNode *treeNode,MyString &result,BOOL isFirst=TRUE);
	void ConfigFacesPlus(Control *control,BOOL isCollaps);

	int OnNextFrame(Timer *timer);
	int OnClick();
};


/*!
\brief
Class de parametre et d'evenement d'une "TreeDirectory"
*/

class TreeDirectory : public TreeView
{
private:
	void Loading(TreeNode *node,char *name,BOOL isCollaps);

	BOOL addFile;
	BOOL addDirectory;
	MyString filter;
	MyString beginPath;

public:
	TreeDirectory();
	void Config(BOOL _addFile,BOOL _addDirectory,char *_filter=NULL);
	void Reset();
	void Loading(char *name,BOOL isCollaps=TRUE);

	int OnClickDirectory(TreeNode *treeNode);
};

#endif