/* ***********************************************************************************
	Writer:		Sebastien Bloc
	Copyright:	2003-2004
	eMail:		sebastien.bloc@free.fr
	URL:		http://mignonsoft.free.fr

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	http://www.gnu.org/copyleft/gpl.html
*********************************************************************************** */

/*! \file univers.h
\brief Control Univers (celui qui contien un monde)
*/

#ifndef INCLUDE_UNIVERS_H
#define INCLUDE_UNIVERS_H

#include "control.h"
#include "tip.h"

/*!
\brief L'univers est le conteneur 3D general (le desktop en 3D)
*/
class Univers : public Control
{
private:
	Tip *tipKey;		//!< tip qui affiche les touche system disponible

	int OnApplyExit(Timer *);
	void UpdateTip();

public:
	BOOL isOnMenu;			//!< est on dans le menu F11 ?
	BOOL isMenuUsing;		//!< y a t'il eut un element du menu utilise ?
	StateMouse oldMouse;

	Univers();
	~Univers();
	virtual void Create();  // Createur pour container
	void ToString(MyString &str);
	void ExitQuestion();
	void HomePosition();

	int OnKeyDown (StateKey *key,int face);
	int OnKeyUp (StateKey *key,int face);
	int OnMouseMove(StateMouse *mouse,int deltaX,int deltaY,int face);
	int OnMouseWheel(StateMouse *mouse,int face);
	int OnLButtonDown(StateMouse *mouse,int face);
	int OnLButtonUp(StateMouse *mouse,int face);
	int OnMButtonDown(StateMouse *mouse,int face);
	int OnMButtonUp(StateMouse *mouse,int face);
	int OnRefresh(Timer *);
	int OnOverIn(Control *,int);
	int OnOverOut(Control *,int);
	int OnExit();
};

#endif